Index: GraphicsMagick-1.2.5/coders/png.c
===================================================================
--- GraphicsMagick-1.2.5.orig/coders/png.c	2018-01-19 20:08:30.737576639 +0100
+++ GraphicsMagick-1.2.5/coders/png.c	2018-01-19 20:29:20.474317244 +0100
@@ -1,5 +1,5 @@
 /*
-% Copyright (C) 2003-2008 GraphicsMagick Group
+% Copyright (C) 2003-2017 GraphicsMagick Group
 % Copyright (C) 2002 ImageMagick Studio
 % Copyright 1991-1999 E. I. du Pont de Nemours and Company
 %
@@ -34,6 +34,7 @@
 */
 
 /* GraphicsMagick differences */
+
 #define LoadImageTag LoadImageText
 #define SaveImageTag SaveImageText
 #define LoadImagesTag LoadImagesText
@@ -57,7 +58,6 @@
 #include "magick/studio.h"
 #include "magick/attribute.h"
 #include "magick/blob.h"
-#include "magick/pixel_cache.h"
 #include "magick/channel.h"
 #include "magick/color.h"
 #include "magick/constitute.h"
@@ -65,22 +65,44 @@
 #include "magick/log.h"
 #include "magick/magick.h"
 #include "magick/monitor.h"
+#include "magick/pixel_cache.h"
 #include "magick/profile.h"
 #include "magick/quantize.h"
 #include "magick/resource.h"
-#include "magick/static.h"
 #include "magick/semaphore.h"
+#include "magick/static.h"
 #include "magick/tempfile.h"
 #include "magick/transform.h"
 #include "magick/utility.h"
+#include "magick/version.h"
 #if defined(HasPNG)
+
+/* Suppress libpng pedantic warnings */
+#define PNG_DEPRECATED  /* Use of this function is deprecated */
+#define PNG_USE_RESULT  /* The result of this function must be checked */
+#define PNG_NORETURN    /* This function does not return */
+/* #define PNG_ALLOCATED */ /* The result of the function is new memory */
+#define PNG_DEPSTRUCT   /* access to this struct member is deprecated */
+
 #include "png.h"
 #include "zlib.h"
+#undef HasLCMS
+#if defined(HasLCMS)
+#  if defined(HAVE_LCMS2_LCMS2_H)
+#    include <lcms2/lcms2.h>
+#  elif defined(HAVE_LCMS2_H)
+#    include <lcms2.h>
+#  else
+#    error "LCMS 2 header missing!"
+#  endif
+#endif
 
-#if PNG_LIBPNG_VER > 95
+
+#if PNG_LIBPNG_VER > 10011
 /*
   Optional declarations. Define or undefine them as you like.
 */
+
 /* #define PNG_DEBUG -- turning this on breaks VisualC compiling */
 
 /*
@@ -90,8 +112,7 @@
 #undef MNG_BASI_SUPPORTED
 #define MNG_COALESCE_LAYERS /* In 5.4.4, this interfered with MMAP'ed files. */
 #define MNG_INSERT_LAYERS   /* Troublesome, but seem to work as of 5.4.4 */
-#define PNG_BUILD_PALETTE   /* This works as of 5.4.3. */
-#define PNG_SORT_PALETTE    /* This works as of 5.4.0. */
+#define GMPNG_BUILD_PALETTE   /* This works as of 5.4.3. */
 #if defined(HasJPEG)
 #  define JNG_SUPPORTED /* Not finished as of 5.5.2.  See "To do" comments. */
 #endif
@@ -101,10 +122,6 @@
   setjmp/longjmp is claimed to be safe on these platforms:
   setjmp/longjmp is alleged to be unsafe on these platforms:
 */
-#ifndef SETJMP_IS_THREAD_SAFE
-#define PNG_SETJMP_NOT_THREAD_SAFE
-#endif
-
 #if defined(PNG_SETJMP_NOT_THREAD_SAFE)
 static SemaphoreInfo
   *png_semaphore = (SemaphoreInfo *) NULL;
@@ -134,10 +151,6 @@ static SemaphoreInfo
   PNG_MNG_FEATURES_SUPPORTED is disabled by default in libpng-1.0.9 and
   will be enabled by default in libpng-1.2.0.
 */
-#if (PNG_LIBPNG_VER == 10009)  /* work around libpng-1.0.9 bug */
-#  undef PNG_READ_EMPTY_PLTE_SUPPORTED
-#  undef PNG_WRITE_EMPTY_PLTE_SUPPORTED
-#endif
 #ifdef PNG_MNG_FEATURES_SUPPORTED
 #  ifndef PNG_READ_EMPTY_PLTE_SUPPORTED
 #    define PNG_READ_EMPTY_PLTE_SUPPORTED
@@ -161,59 +174,72 @@ static SemaphoreInfo
   portable, we use ASCII numbers like this, not characters.
 */
 
-static png_byte FARDATA mng_MHDR[5]={ 77,  72,  68,  82, '\0'};
-static png_byte FARDATA mng_BACK[5]={ 66,  65,  67,  75, '\0'};
-static png_byte FARDATA mng_BASI[5]={ 66,  65,  83,  73, '\0'};
-static png_byte FARDATA mng_CLIP[5]={ 67,  76,  73,  80, '\0'};
-static png_byte FARDATA mng_CLON[5]={ 67,  76,  79,  78, '\0'};
-static png_byte FARDATA mng_DEFI[5]={ 68,  69,  70,  73, '\0'};
-static png_byte FARDATA mng_DHDR[5]={ 68,  72,  68,  82, '\0'};
-static png_byte FARDATA mng_DISC[5]={ 68,  73,  83,  67, '\0'};
-static png_byte FARDATA mng_ENDL[5]={ 69,  78,  68,  76, '\0'};
-static png_byte FARDATA mng_FRAM[5]={ 70,  82,  65,  77, '\0'};
-static png_byte FARDATA mng_IEND[5]={ 73,  69,  78,  68, '\0'};
-static png_byte FARDATA mng_IHDR[5]={ 73,  72,  68,  82, '\0'};
-static png_byte FARDATA mng_JHDR[5]={ 74,  72,  68,  82, '\0'};
-static png_byte FARDATA mng_LOOP[5]={ 76,  79,  79,  80, '\0'};
-static png_byte FARDATA mng_MAGN[5]={ 77,  65,  71,  78, '\0'};
-static png_byte FARDATA mng_MEND[5]={ 77,  69,  78,  68, '\0'};
-static png_byte FARDATA mng_MOVE[5]={ 77,  79,  86,  69, '\0'};
-static png_byte FARDATA mng_PAST[5]={ 80,  65,  83,  84, '\0'};
-static png_byte FARDATA mng_PLTE[5]={ 80,  76,  84,  69, '\0'};
-static png_byte FARDATA mng_SAVE[5]={ 83,  65,  86,  69, '\0'};
-static png_byte FARDATA mng_SEEK[5]={ 83,  69,  69,  75, '\0'};
-static png_byte FARDATA mng_SHOW[5]={ 83,  72,  79,  87, '\0'};
-static png_byte FARDATA mng_TERM[5]={ 84,  69,  82,  77, '\0'};
-static png_byte FARDATA mng_bKGD[5]={ 98,  75,  71,  68, '\0'};
-static png_byte FARDATA mng_cHRM[5]={ 99,  72,  82,  77, '\0'};
-static png_byte FARDATA mng_gAMA[5]={103,  65,  77,  65, '\0'};
-static png_byte FARDATA mng_iCCP[5]={105,  67,  67,  80, '\0'};
-static png_byte FARDATA mng_nEED[5]={110,  69,  69,  68, '\0'};
-static png_byte FARDATA mng_pHYg[5]={112,  72,  89, 103, '\0'};
-static png_byte FARDATA mng_pHYs[5]={112,  72,  89, 115, '\0'};
-static png_byte FARDATA mng_sBIT[5]={115,  66,  73,  84, '\0'};
-static png_byte FARDATA mng_sRGB[5]={115,  82,  71,  66, '\0'};
-static png_byte FARDATA mng_tRNS[5]={116,  82,  78,  83, '\0'};
+static png_byte const mng_MHDR[5]={ 77,  72,  68,  82, '\0'};
+static png_byte const mng_BACK[5]={ 66,  65,  67,  75, '\0'};
+static png_byte const mng_BASI[5]={ 66,  65,  83,  73, '\0'};
+static png_byte const mng_CLIP[5]={ 67,  76,  73,  80, '\0'};
+static png_byte const mng_CLON[5]={ 67,  76,  79,  78, '\0'};
+static png_byte const mng_DEFI[5]={ 68,  69,  70,  73, '\0'};
+static png_byte const mng_DHDR[5]={ 68,  72,  68,  82, '\0'};
+static png_byte const mng_DISC[5]={ 68,  73,  83,  67, '\0'};
+static png_byte const mng_ENDL[5]={ 69,  78,  68,  76, '\0'};
+static png_byte const mng_FRAM[5]={ 70,  82,  65,  77, '\0'};
+static png_byte const mng_IEND[5]={ 73,  69,  78,  68, '\0'};
+static png_byte const mng_IHDR[5]={ 73,  72,  68,  82, '\0'};
+static png_byte const mng_JHDR[5]={ 74,  72,  68,  82, '\0'};
+static png_byte const mng_LOOP[5]={ 76,  79,  79,  80, '\0'};
+static png_byte const mng_MAGN[5]={ 77,  65,  71,  78, '\0'};
+static png_byte const mng_MEND[5]={ 77,  69,  78,  68, '\0'};
+static png_byte const mng_MOVE[5]={ 77,  79,  86,  69, '\0'};
+static png_byte const mng_PAST[5]={ 80,  65,  83,  84, '\0'};
+static png_byte const mng_PLTE[5]={ 80,  76,  84,  69, '\0'};
+static png_byte const mng_SAVE[5]={ 83,  65,  86,  69, '\0'};
+static png_byte const mng_SEEK[5]={ 83,  69,  69,  75, '\0'};
+static png_byte const mng_SHOW[5]={ 83,  72,  79,  87, '\0'};
+static png_byte const mng_TERM[5]={ 84,  69,  82,  77, '\0'};
+static png_byte const mng_bKGD[5]={ 98,  75,  71,  68, '\0'};
+static png_byte const mng_caNv[5]={ 99,  97,  78, 118, '\0'};
+static png_byte const mng_cHRM[5]={ 99,  72,  82,  77, '\0'};
+static png_byte const mng_eXIf[5]={101,  88,  73, 102, '\0'};
+static png_byte const mng_gAMA[5]={103,  65,  77,  65, '\0'};
+static png_byte const mng_iCCP[5]={105,  67,  67,  80, '\0'};
+static png_byte const mng_nEED[5]={110,  69,  69,  68, '\0'};
+static png_byte const mng_orNT[5]={111, 114,  78,  84, '\0'};
+static png_byte const mng_pHYg[5]={112,  72,  89, 103, '\0'};
+static png_byte const mng_pHYs[5]={112,  72,  89, 115, '\0'};
+static png_byte const mng_sBIT[5]={115,  66,  73,  84, '\0'};
+static png_byte const mng_sRGB[5]={115,  82,  71,  66, '\0'};
+static png_byte const mng_tRNS[5]={116,  82,  78,  83, '\0'};
 
 #if defined(JNG_SUPPORTED)
-static png_byte FARDATA mng_IDAT[5]={ 73,  68,  65,  84, '\0'};
-static png_byte FARDATA mng_JDAT[5]={ 74,  68,  65,  84, '\0'};
-static png_byte FARDATA mng_JDAA[5]={ 74,  68,  65,  65, '\0'};
-static png_byte FARDATA mng_JdAA[5]={ 74, 100,  65,  65, '\0'};
-static png_byte FARDATA mng_JSEP[5]={ 74,  83,  69,  80, '\0'};
-static png_byte FARDATA mng_oFFs[5]={111,  70,  70, 115, '\0'};
+static png_byte const mng_IDAT[5]={ 73,  68,  65,  84, '\0'};
+static png_byte const mng_JDAT[5]={ 74,  68,  65,  84, '\0'};
+static png_byte const mng_JDAA[5]={ 74,  68,  65,  65, '\0'};
+static png_byte const mng_JdAA[5]={ 74, 100,  65,  65, '\0'};
+static png_byte const mng_JSEP[5]={ 74,  83,  69,  80, '\0'};
+static png_byte const mng_oFFs[5]={111,  70,  70, 115, '\0'};
 #endif
 
 /*
-static png_byte FARDATA mng_hIST[5]={104,  73,  83,  84, '\0'};
-static png_byte FARDATA mng_iCCP[5]={105,  67,  67,  80, '\0'};
-static png_byte FARDATA mng_iTXt[5]={105,  84,  88, 116, '\0'};
-static png_byte FARDATA mng_sPLT[5]={115,  80,  76,  84, '\0'};
-static png_byte FARDATA mng_tEXt[5]={116,  69,  88, 116, '\0'};
-static png_byte FARDATA mng_tIME[5]={116,  73,  77,  69, '\0'};
-static png_byte FARDATA mng_zTXt[5]={122,  84,  88, 116, '\0'};
+static png_byte const mng_hIST[5]={104,  73,  83,  84, '\0'};
+static png_byte const mng_iCCP[5]={105,  67,  67,  80, '\0'};
+static png_byte const mng_iTXt[5]={105,  84,  88, 116, '\0'};
+static png_byte const mng_sPLT[5]={115,  80,  76,  84, '\0'};
+static png_byte const mng_tEXt[5]={116,  69,  88, 116, '\0'};
+static png_byte const mng_tIME[5]={116,  73,  77,  69, '\0'};
+static png_byte const mng_zTXt[5]={122,  84,  88, 116, '\0'};
 */
 
+typedef struct _UShortPixelPacket
+{
+  unsigned short
+    red,
+    green,
+    blue,
+    opacity,
+    index;
+} UShortPixelPacket;
+
 typedef struct _MngBox
 {
   long
@@ -307,7 +333,6 @@ typedef struct _MngInfo
     need_fram,
     object_id,
     old_framing_mode,
-    optimize,
     saved_bkgd_index;
 
   int
@@ -384,9 +409,13 @@ typedef struct _MngInfo
     show_warning,
     mng_type,
     write_mng,
+    write_png_colortype,
+    write_png_depth,
     write_png8,
     write_png24,
-    write_png32;
+    write_png32,
+    write_png48,
+    write_png64;
 
 #ifdef MNG_BASI_SUPPORTED
   unsigned long
@@ -421,6 +450,12 @@ typedef struct _MngInfo
   PixelPacket
     mng_global_bkgd;
 
+  unsigned char
+    *png_pixels;
+
+  Quantum
+    *quantum_scanline;
+
 } MngInfo;
 #endif /* VER */
 
@@ -435,6 +470,7 @@ static unsigned int
 static unsigned int
   WriteJNGImage(const ImageInfo *,Image *);
 #endif
+
 static const char* PngColorTypeToString(const unsigned int color_type)
 {
   const char
@@ -461,8 +497,7 @@ static const char* PngColorTypeToString(
 
   return result;
 }
-
-
+#endif /* HasPNG */
 static size_t MagickArraySize(const size_t count, const size_t size)
 {
   size_t
@@ -476,285 +511,6 @@ static size_t MagickArraySize(const size
 }
 
 
-#if PNG_LIBPNG_VER > 95
-#if defined(PNG_SORT_PALETTE)
-/*
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-%                                                                             %
-%                                                                             %
-%                                                                             %
-%   C o m p r e s s C o l o r m a p T r a n s F i r s t                       %
-%                                                                             %
-%                                                                             %
-%                                                                             %
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-%
-%  Method CompressColormapTransFirst compresses an image colormap removing
-%  any duplicate and unused color entries and putting the transparent colors
-%  first.
-%
-%  The format of the CompressColormapTransFirst method is:
-%
-%      unsigned int CompressColormapTransFirst(Image *image)
-%
-%  A description of each parameter follows:
-%
-%    o image: The address of a structure of type Image.
-%
-%
-*/
-static unsigned int CompressColormapTransFirst(Image *image)
-{
-  int
-    remap_needed,
-    k;
-
-  long
-    j,
-    new_number_colors,
-    number_colors,
-    y;
-
-  PixelPacket
-    *colormap;
-
-  register const PixelPacket
-    *p;
-
-  register IndexPacket
-    *indexes,
-    top_used;
-
-  register long
-    i,
-    x;
-
-  IndexPacket
-    *map,
-    *opacity;
-
-  unsigned char
-    *marker,
-    have_transparency;
-
-  /*
-    Determine if colormap can be compressed.
-  */
-  assert(image != (Image *) NULL);
-  if (image->storage_class != PseudoClass || image->colors > 256 ||
-      image->colors < 2)
-    return(False);
-  marker=MagickAllocateMemory(unsigned char *,image->colors);
-  if (marker == (unsigned char *) NULL)
-    ThrowBinaryException(ResourceLimitError,MemoryAllocationFailed,
-                         "Unable to compress image colormap")
-      opacity=MagickAllocateMemory(IndexPacket *,
-                                   image->colors*sizeof(IndexPacket));
-  if (opacity == (IndexPacket *) NULL)
-    {
-      MagickFreeMemory(marker);
-      ThrowBinaryException(ResourceLimitError,MemoryAllocationFailed,
-                           "Unable to compress image colormap")
-        }
-  /*
-    Mark colors that are present.
-  */
-  number_colors=(long) image->colors;
-  for (i=0; i < number_colors; i++)
-    {
-      marker[i]=False;
-      opacity[i]=OpaqueOpacity;
-    }
-  top_used=0;
-  for (y=0; y < (long) image->rows; y++)
-    {
-      p=AcquireImagePixels(image,0,y,image->columns,1,&image->exception);
-      if (p == (const PixelPacket *) NULL)
-        break;
-      indexes=GetIndexes(image);
-      if (image->matte)
-        for (x=0; x < (long) image->columns; x++)
-          {
-            marker[(int) indexes[x]]=True;
-            opacity[(int) indexes[x]]=p->opacity;
-            if (indexes[x] > top_used)
-              top_used=indexes[x];
-            p++;
-          }
-      else
-        for (x=0; x < (long) image->columns; x++)
-          {
-            marker[(int) indexes[x]]=True;
-            if (indexes[x] > top_used)
-              top_used=indexes[x];
-          }
-    }
-
-  if (image->matte)
-    {
-      /*
-        Mark background color, topmost occurrence if more than one.
-      */
-      for (i=number_colors-1; i; i--)
-        {
-          if (RGBColorMatchExact(image->colormap[i],image->background_color))
-            {
-              marker[i]=True;
-              break;
-            }
-        }
-    }
-  /*
-    Unmark duplicates.
-  */
-  for (i=0; i < number_colors-1; i++)
-    if (marker[i])
-      {
-        for (j=i+1; j < number_colors; j++)
-          if ((opacity[i] == opacity[j]) &&
-              (RGBColorMatchExact(image->colormap[i],image->colormap[j])))
-            marker[j]=False;
-      }
-  /*
-    Count colors that still remain.
-  */
-  have_transparency=False;
-  new_number_colors=0;
-  for (i=0; i < number_colors; i++)
-    if (marker[i])
-      {
-        new_number_colors++;
-        if (opacity[i] != OpaqueOpacity)
-          have_transparency=True;
-      }
-  if ((!have_transparency || (marker[0] && (opacity[0] == TransparentOpacity)))
-      && (new_number_colors == number_colors))
-    {
-      /*
-        No duplicate or unused entries, and transparency-swap not needed
-      */
-      MagickFreeMemory(marker);
-      MagickFreeMemory(opacity);
-      return(True);
-    }
-
-  remap_needed=False;
-  if ((long) top_used >= new_number_colors)
-    remap_needed=True;
-
-  /*
-    Compress colormap.
-  */
-
-  colormap=MagickAllocateMemory(PixelPacket *,
-                                image->colors*sizeof(PixelPacket));
-  if (colormap == (PixelPacket *) NULL)
-    {
-      MagickFreeMemory(marker);
-      MagickFreeMemory(opacity);
-      ThrowBinaryException(ResourceLimitError,MemoryAllocationFailed,
-                           "Unable to compress image colormap")
-        }
-  /*
-    Eliminate unused colormap entries.
-  */
-  map=MagickAllocateMemory(IndexPacket *,number_colors*sizeof(IndexPacket));
-  if (map == (IndexPacket *) NULL)
-    {
-      MagickFreeMemory(marker);
-      MagickFreeMemory(opacity);
-      MagickFreeMemory(colormap);
-      ThrowBinaryException(ResourceLimitError,MemoryAllocationFailed,
-                           "Unable to compress image colormap")
-        }
-  k=0;
-  for (i=0; i < number_colors; i++)
-    {
-      map[i]=(IndexPacket) k;
-      if (marker[i])
-        {
-          for (j=i+1; j < number_colors; j++)
-            {
-              if ((opacity[i] == opacity[j]) &&
-                  (RGBColorMatchExact(image->colormap[i],image->colormap[j])))
-                {
-                  map[j]=(IndexPacket) k;
-                  marker[j]=False;
-                }
-            }
-          k++;
-        }
-    }
-  j=0;
-  for (i=0; i < number_colors; i++)
-    {
-      if (marker[i])
-        {
-          colormap[j]=image->colormap[i];
-          j++;
-        }
-    }
-  if (have_transparency && (opacity[0] != TransparentOpacity))
-    {
-      /*
-        Move the first transparent color to palette entry 0.
-      */
-      for (i=1; i < number_colors; i++)
-        {
-          if (marker[i] && opacity[i] == TransparentOpacity)
-            {
-              PixelPacket
-                temp_colormap;
-
-              temp_colormap=colormap[0];
-              colormap[0]=colormap[(int) map[i]];
-              colormap[map[i]]=temp_colormap;
-              for (j=0; j < number_colors; j++)
-                {
-                  if (map[j] == 0)
-                    map[j]=map[i];
-                  else if (map[j] == map[i])
-                    map[j]=0;
-                }
-              remap_needed=True;
-              break;
-            }
-        }
-    }
-
-  MagickFreeMemory(opacity);
-  MagickFreeMemory(marker);
-
-  if (remap_needed)
-    {
-      /*
-        Remap pixels.
-      */
-      for (y=0; y < (long) image->rows; y++)
-        {
-          p=AcquireImagePixels(image,0,y,image->columns,1,&image->exception);
-          if (p == (const PixelPacket *) NULL)
-            break;
-          indexes=GetIndexes(image);
-          for (x=0; x < (long) image->columns; x++)
-            {
-              j=(int) indexes[x];
-              indexes[x]=map[j];
-            }
-          if (!SyncImagePixels(image))
-            break;
-        }
-      for (i=0; i < new_number_colors; i++)
-        image->colormap[i]=colormap[i];
-    }
-  MagickFreeMemory(colormap);
-  image->colors=new_number_colors;
-  MagickFreeMemory(map);
-  return(True);
-}
-#endif
-#endif /* PNG_LIBPNG_VER > 95 */
-#endif /* HasPNG */
 
 /*
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@@ -785,13 +541,13 @@ static unsigned int CompressColormapTran
 %
 %
 */
-static unsigned int IsMNG(const unsigned char *magick,const size_t length)
+static MagickPassFail IsMNG(const unsigned char *magick,const size_t length)
 {
   if (length < 8)
-    return(False);
+    return(MagickFail);
   if (memcmp(magick,"\212MNG\r\n\032\n",8) == 0)
-    return(True);
-  return(False);
+    return(MagickPass);
+  return(MagickFail);
 }
 
 /*
@@ -823,13 +579,13 @@ static unsigned int IsMNG(const unsigned
 %
 %
 */
-static unsigned int IsJNG(const unsigned char *magick,const size_t length)
+static MagickPassFail IsJNG(const unsigned char *magick,const size_t length)
 {
   if (length < 8)
-    return(False);
+    return(MagickFail);
   if (memcmp(magick,"\213JNG\r\n\032\n",8) == 0)
-    return(True);
-  return(False);
+    return(MagickPass);
+  return(MagickFail);
 }
 
 /*
@@ -861,13 +617,13 @@ static unsigned int IsJNG(const unsigned
 %
 %
 */
-static unsigned int IsPNG(const unsigned char *magick,const size_t length)
+static MagickPassFail IsPNG(const unsigned char *magick,const size_t length)
 {
   if (length < 8)
-    return(False);
+    return(MagickFail);
   if (memcmp(magick,"\211PNG\r\n\032\n",8) == 0)
-    return(True);
-  return(False);
+    return(MagickPass);
+  return(MagickFail);
 }
 
 #if defined(HasPNG)
@@ -875,7 +631,7 @@ static unsigned int IsPNG(const unsigned
 extern "C" {
 #endif
 
-#if (PNG_LIBPNG_VER > 95)
+#if (PNG_LIBPNG_VER > 10011)
 static size_t WriteBlobMSBULong(Image *image,const unsigned long value)
 {
   unsigned char
@@ -912,25 +668,25 @@ static void PNGShort(png_bytep p,png_uin
   *p++=(png_byte) (value & 0xff);
 }
 
-static void PNGType(png_bytep p,png_bytep type)
+static void PNGType(png_bytep p,png_byte const * type)
 {
   (void) memcpy(p,type,4*sizeof(png_byte));
 }
 
-static void LogPNGChunk(int logging, png_bytep type, unsigned long length)
+static void LogPNGChunk(int logging, png_byte const * type, size_t length)
 {
   if (logging)
     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
         "  Writing %c%c%c%c chunk, length: %lu",
         type[0],type[1],type[2],type[3],length);
 }
-#endif /* PNG_LIBPNG_VER > 95 */
+#endif /* PNG_LIBPNG_VER > 10011 */
 
 #if defined(__cplusplus) || defined(c_plusplus)
 }
 #endif
 
-#if PNG_LIBPNG_VER > 95
+#if PNG_LIBPNG_VER > 10011
 /*
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %                                                                             %
@@ -951,7 +707,8 @@ static void LogPNGChunk(int logging, png
 %
 %  The format of the ReadPNGImage method is:
 %
-%      Image *ReadPNGImage(const ImageInfo *image_info,ExceptionInfo *exception)
+%      Image *ReadPNGImage(const ImageInfo *image_info,
+%                          ExceptionInfo *exception)
 %
 %  A description of each parameter follows:
 %
@@ -1012,6 +769,13 @@ static void LogPNGChunk(int logging, png
 %    Upgrade to full MNG with Delta-PNG.
 %
 %    JNG tEXt/iTXt/zTXt
+%
+%    We will not attempt to read files containing the CgBI chunk.
+%    They are really Xcode files meant for display on the iPhone.
+%    These are not valid PNG files and it is impossible to recover
+%    the orginal PNG from files that have been converted to Xcode-PNG,
+%    since irretrievable loss of color data has occurred due to the
+%    use of premultiplied alpha.
 */
 
 #if defined(__cplusplus) || defined(c_plusplus)
@@ -1033,7 +797,7 @@ static void png_get_data(png_structp png
     {
       png_size_t
         check;
-      
+
       if (length > 0x7fffffff)
         png_warning(png_ptr, "chunk length > 2G");
       check=(png_size_t) ReadBlob(image,(size_t) length,(char *) data);
@@ -1041,9 +805,9 @@ static void png_get_data(png_structp png
         {
           char
             msg[MaxTextExtent];
-          
-          (void) sprintf(msg,"Expected %lu bytes; found %lu bytes",
-                         (unsigned long) length,(unsigned long) check);
+
+            (void) sprintf(msg,"Expected %lu bytes; found %lu bytes",
+                           (unsigned long) length,(unsigned long) check);
           png_warning(png_ptr,msg);
           png_error(png_ptr,"Read Exception");
         }
@@ -1064,16 +828,16 @@ static void mng_get_data(png_structp png
 {
   MngInfo
     *mng_info;
-  
+
   Image
     *image;
-  
+
   png_size_t
     check;
-  
+
   register long
     i;
-  
+
   i=0;
   mng_info=(MngInfo *) png_get_io_ptr(png_ptr);
   image=(Image *) mng_info->image;
@@ -1099,11 +863,11 @@ static void mng_get_data(png_structp png
               mng_info->read_buffer[4]=0;
               mng_info->bytes_in_read_buffer=4;
               if (!memcmp(mng_info->read_buffer,mng_PLTE,4))
-                mng_info->found_empty_plte=True;
+                mng_info->found_empty_plte=MagickTrue;
               if (!memcmp(mng_info->read_buffer,mng_IEND,4))
                 {
-                  mng_info->found_empty_plte=False;
-                  mng_info->have_saved_bkgd_index=False;
+                  mng_info->found_empty_plte=MagickFalse;
+                  mng_info->have_saved_bkgd_index=MagickFalse;
                 }
             }
           if ((data[0] == 0) && (data[1] == 0) && (data[2] == 0) &&
@@ -1122,9 +886,10 @@ static void mng_get_data(png_structp png
                     check=(png_size_t)
                       ReadBlob(image,5,(char *) mng_info->read_buffer);
                     check=(png_size_t) ReadBlob(image,(size_t) length,
-                                                (char *) mng_info->read_buffer);
+                                                (char *)
+                                                mng_info->read_buffer);
                     mng_info->saved_bkgd_index=mng_info->read_buffer[0];
-                    mng_info->have_saved_bkgd_index=True;
+                    mng_info->have_saved_bkgd_index=MagickTrue;
                     mng_info->bytes_in_read_buffer=0;
                   }
             }
@@ -1137,13 +902,13 @@ static void png_put_data(png_structp png
 {
   Image
     *image;
-  
+
   image=(Image *) png_get_io_ptr(png_ptr);
   if (length)
     {
       png_size_t
         check;
-      
+
       check=(png_size_t) WriteBlob(image,(unsigned long) length,(char *) data);
       if (check != length)
         png_error(png_ptr,"WriteBlob Failed");
@@ -1153,12 +918,12 @@ static void png_put_data(png_structp png
 static void png_flush_data(png_structp png_ptr)
 {
   ARG_NOT_USED(png_ptr);
-  
+
   /* There is currently no safe API to "flush" a blob. */
 #if 0
   Image
     *image;
-  
+
   image=(Image *) png_get_io_ptr(png_ptr);
   (void) SyncBlob(image);
 #endif
@@ -1169,21 +934,21 @@ static int PalettesAreEqual(Image *a,Ima
 {
   long
     i;
-  
+
   if ((a == (Image *) NULL) || (b == (Image *) NULL))
-    return((int) False);
+    return(MagickFail);
   if (a->storage_class!=PseudoClass || b->storage_class!=PseudoClass)
-    return((int) False);
+    return(MagickFail);
   if (a->colors != b->colors)
-    return((int) False);
+    return(MagickFail);
   for (i=0; i < (long) a->colors; i++)
     {
       if ((a->colormap[i].red != b->colormap[i].red) ||
           (a->colormap[i].green != b->colormap[i].green) ||
           (a->colormap[i].blue != b->colormap[i].blue))
-        return((int) False);
+        return(MagickFail);
     }
-  return((int) True);
+  return((int) MagickTrue);
 }
 #endif
 
@@ -1200,16 +965,19 @@ static void MngInfoDiscardObject(MngInfo
           if (mng_info->ob[i]->reference_count == 0)
             {
               if (mng_info->ob[i]->image != (Image *) NULL)
-                DestroyImage(mng_info->ob[i]->image);
+                {
+                  DestroyImage(mng_info->ob[i]->image);
+                  mng_info->ob[i]->image=(Image *) NULL;
+                }
               MagickFreeMemory(mng_info->ob[i]);
             }
         }
       mng_info->ob[i]=(MngBuffer *) NULL;
 #endif
-      mng_info->exists[i]=False;
-      mng_info->invisible[i]=False;
-      mng_info->viewable[i]=False;
-      mng_info->frozen[i]=False;
+      mng_info->exists[i]=MagickFalse;
+      mng_info->invisible[i]=MagickFalse;
+      mng_info->viewable[i]=MagickFalse;
+      mng_info->frozen[i]=MagickFalse;
       mng_info->x_off[i]=0;
       mng_info->y_off[i]=0;
       mng_info->object_clip[i].left=0;
@@ -1225,13 +993,13 @@ static void MngInfoFreeStruct(MngInfo *m
     {
       register long
         i;
-      
+
       for (i=1; i < MNG_MAX_OBJECTS; i++)
         MngInfoDiscardObject(mng_info,i);
-      if (mng_info->global_plte != (png_colorp) NULL)
-        MagickFreeMemory(mng_info->global_plte);
+      mng_info->image=(Image *)NULL;
+      MagickFreeMemory(mng_info->global_plte);
       MagickFreeMemory(mng_info);
-      *have_mng_structure=False;
+      *have_mng_structure=MagickFalse;
     }
 }
 
@@ -1239,7 +1007,7 @@ static MngBox mng_minimum_box(MngBox box
 {
   MngBox
     box;
-  
+
   box=box1;
   if (box.left < box2.left)
     box.left=box2.left;
@@ -1252,18 +1020,27 @@ static MngBox mng_minimum_box(MngBox box
   return box;
 }
 
-static MngBox mng_read_box(MngBox previous_box,char delta_type,unsigned char *p)
+static long mng_get_long(unsigned char *p)
+{
+  return ((long) (((magick_uint32_t) p[0] << 24) |
+                  ((magick_uint32_t) p[1] << 16) |
+                  ((magick_uint32_t) p[2] <<  8) |
+                  (magick_uint32_t)  p[3]));
+}
+
+static MngBox mng_read_box(MngBox previous_box,char delta_type,
+                           unsigned char *p)
 {
   MngBox
     box;
-  
+
   /*
     Read clipping boundaries from DEFI, CLIP, FRAM, or PAST chunk.
   */
-  box.left=(long) ((p[0]  << 24) | (p[1]  << 16) | (p[2]  << 8) | p[3]);
-  box.right=(long) ((p[4]  << 24) | (p[5]  << 16) | (p[6]  << 8) | p[7]);
-  box.top=(long) ((p[8]  << 24) | (p[9]  << 16) | (p[10] << 8) | p[11]);
-  box.bottom=(long) ((p[12] << 24) | (p[13] << 16) | (p[14] << 8) | p[15]);
+  box.left  = mng_get_long(p);
+  box.right = mng_get_long(&p[4]);
+  box.top   = mng_get_long(&p[8]);
+  box.bottom= mng_get_long(&p[12]);
   if (delta_type != 0)
     {
       box.left+=previous_box.left;
@@ -1282,8 +1059,9 @@ static MngPair mng_read_pair(MngPair pre
   /*
     Read two longs from CLON, MOVE or PAST chunk
   */
-  pair.a=(long) ((p[0] << 24) | (p[1] << 16) | (p[2] << 8) | p[3]);
-  pair.b=(long) ((p[4] << 24) | (p[5] << 16) | (p[6] << 8) | p[7]);
+  pair.a= mng_get_long(p);
+  pair.b= mng_get_long(&p[4]);
+
   if (delta_type != 0)
     {
       pair.a+=previous_pair.a;
@@ -1292,34 +1070,34 @@ static MngPair mng_read_pair(MngPair pre
   return(pair);
 }
 
-static long mng_get_long(unsigned char *p)
-{
-  return((long) ((p[0] << 24) | (p[1] << 16) | (p[2] << 8) | p[3]));
-}
-
 static void PNGErrorHandler(png_struct *ping,png_const_charp message)
 {
   Image
     *image;
-  
+
   image=(Image *) png_get_error_ptr(ping);
   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                        "  libpng-%.1024s error: %.1024s", PNG_LIBPNG_VER_STRING,
-                        message);
+                        "  libpng-%.1024s error: %.1024s",
+                        PNG_LIBPNG_VER_STRING, message);
   (void) ThrowException2(&image->exception,CoderError,message,image->filename);
+#if (PNG_LIBPNG_VER < 10500)
   longjmp(ping->jmpbuf,1);
+#else
+  png_longjmp(ping,1);
+#endif
+  SignalHandlerExit(1); /* Avoid GCC warning about non-exit function which does exit */
 }
 
 static void PNGWarningHandler(png_struct *ping,png_const_charp message)
 {
   Image
     *image;
-  
+
   if (LocaleCompare(message, "Missing PLTE before tRNS") == 0)
     png_error(ping, message);
   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                        "  libpng-%.1024s warning: %.1024s", PNG_LIBPNG_VER_STRING,
-                        message);
+                        "  libpng-%.1024s warning: %.1024s",
+                        PNG_LIBPNG_VER_STRING, message);
   image=(Image *) png_get_error_ptr(ping);
   (void) ThrowException2(&image->exception,CoderWarning,message,
                          image->filename);
@@ -1332,19 +1110,8 @@ static png_voidp png_IM_malloc(png_struc
 static png_voidp png_IM_malloc(png_structp png_ptr,png_size_t size)
 #endif
 {
-#if (PNG_LIBPNG_VER < 10011)
-  png_voidp
-    ret;
-  
-  png_ptr=png_ptr;
-  ret=MagickAllocateMemory(png_voidp,(size_t) size);
-  if (ret == NULL)
-    png_error("Insufficient memory.");
-  return (ret);
-#else
-  png_ptr=png_ptr;
+  (void) png_ptr;
   return MagickAllocateMemory(png_voidp,(size_t) size);
-#endif
 }
 
 /*
@@ -1352,7 +1119,7 @@ static png_voidp png_IM_malloc(png_struc
 */
 static png_free_ptr png_IM_free(png_structp png_ptr,png_voidp ptr)
 {
-  png_ptr=png_ptr;
+  (void) png_ptr;
   MagickFreeMemory(ptr);
   return((png_free_ptr) NULL);
 }
